#!/bin/bash

################################################
##  Run experiments and compute the performances
##
##  SV - version 1 - 12/11/2014
################################################

################################################
## parameters

# directory with executables
exeDir=/Users/verel/enseignement/14-15/RO/prj2/docking-cor/build

# directory with data
dataDir=/Users/verel/enseignement/14-15/RO/prj2/docking-cor/data

# directory of save the experiments
dataExpe=expe

# search algorithm
exe=example3_randomSearch

# output file with results
output=results.csv

# number of runs
nbRuns=3

# list of receptor/ligands
complexeList="1ACB 1ATN	1F34	1KAC	2I25 1AK4	1DFJ	1GHQ	1LFD	2UUY"

################################################
## Execute the search algorithm on the benchmark

echo "*** Compute the runs"

for complexe in ${complexeList}
do
  for((i=0;i<nbRuns;i++))
  do
    solName=${dataExpe}/${exe}_${complexe}_${i}.sol
    echo ${solName}
    ${exeDir}/${exe} ${dataDir}/${complexe}/receptor_b.red2 ${dataDir}/${complexe}/ligand_rnd.red2 $i > ${solName}
  done
done

################################################
## Compare the solution to the reference position

echo "*** Compute the performances"

echo "method complexe id ref energy rmsd" > ${output}

for complexe in ${complexeList}
do
  for((i=0;i<nbRuns;i++))
  do
    solName=${dataExpe}/${exe}_${complexe}_${i}.sol

    echo -n ${exe} ${complexe} ${i}' ' >> ${output}
    ${exeDir}/compare ${dataDir}/${complexe}/receptor_b.red2 ${dataDir}/${complexe}/ligand_ref.red2 ${dataDir}/${complexe}/ligand_rnd.red2 ${solName} >> ${output}
  done
done