#ifndef __RandomES__h
#define __RandomES__h

/*
 * Description:
 *   Random search
 *
 * Author : SV
 *
 * Date   : 
 *   version 1 - 2014-11-12
 */

#include <minimizers/algo/es.h>
#include <minimizers/solution/solution.h>
#include <minimizers/solution/eval.h>
#include <minimizers/init/init.h>

class RandomES : public EvolutionStrategy {
public:
  /*
   * Constructor
   * 
   * @param _rng random generator
   * @param _eval evaluation function
   * @param _init initialisation method
   */
  RandomES(std::mt19937 & _rng, Eval & _eval, Init & _init) : EvolutionStrategy(_rng, _eval), init(_init) {
  }

  /*
   * Execute the optimization algorithm : random search
   *
   */
  virtual void run() {
    // random initialization
    init.apply(bestSolution);
    
    // evaluation
    eval.apply(bestSolution);
  }

protected:
  // initialization method
  Init & init;
  
};

#endif
