#ifndef __Eval__h
#define __Eval__h

// include to compute the energy function
#include <attractforcefield.h>
#include <attractrigidbody.h>

/*
 * Evaluation function that computes the energy
 * 
 * Author : SV
 * Date   : 
 *   version 1 - 2013-11-05
 */

#include <basetypes.h>

class Eval {
public:
  /*
    Empty constructor
  */
  Eval(const std::string & paramFile, PTools::AttractRigidbody & receptor, PTools::AttractRigidbody & ligand) : rec(receptor), lig(ligand), forceField(paramFile, 999999) {
    // fix the receptor

    rec.setRotation(false);
    rec.setTranslation(false);
    
    // define the field of energy function to minimize

    forceField.AddLigand(rec);
    forceField.AddLigand(lig);
  }

  /*
   * Compute the fitness value
   *
   */
  void apply(Solution & solution) {
    solution.fitness( forceField.Function(solution.coord) );
  }

private:
  PTools::AttractRigidbody rec;
  PTools::AttractRigidbody lig;

  PTools::AttractForceField2 forceField;
};

#endif
